"use strict";
cc._RF.push(module, '1959f+O4mFJv50c4biwLxpJ', 'Box');
// Script/Box.ts

"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Box = /** @class */ (function (_super) {
    __extends(Box, _super);
    function Box() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.nodeCamera = null;
        _this.nodeBox = null;
        _this.nodeMyBox = null;
        _this.curPage = 0;
        _this.rotationDir = 0;
        _this.totalDegree = 0;
        return _this;
    }
    // ba = [[], [5, 6, 4, 2], [5, 6, 1, 3], [5, 6, 2, 4], []];
    // LIFE-CYCLE CALLBACKS:
    Box.prototype.onLoad = function () {
        this.nodeBox.active = false;
    };
    Box.prototype.start = function () {
    };
    Box.prototype.update = function (dt) {
        if (!this.rotationDir)
            return;
        var v3 = this.nodeMyBox.eulerAngles;
        console.log("##", v3);
        // let out: cc.Quat = new cc.Quat();
        // let curQuad = new cc.Quat(0, 0, 0, 1);
        // (this.nodeMyBox as any).getWorldRotation(out);
        var degree = dt * 90;
        this.totalDegree += degree;
        if (this.totalDegree > 90) {
            degree -= this.totalDegree - 90;
        }
        // let radius = degree * Math.PI / 360;
        if (this.rotationDir == 1) {
            v3.x += degree;
            // curQuad.x = Math.sin(radius);
            // curQuad.w = Math.cos(radius);
        }
        else if (this.rotationDir == 2) {
            v3.x -= degree;
            // curQuad.x = Math.sin(-radius);
            // curQuad.w = Math.cos(-radius);
        }
        else if (this.rotationDir == 3) {
            v3.y += degree;
            // curQuad.y = Math.sin(radius);
            // curQuad.w = Math.cos(radius);
        }
        else if (this.rotationDir == 4) {
            v3.y -= degree;
            // curQuad.y = Math.sin(-radius);
            // curQuad.w = Math.cos(-radius);
        }
        else if (this.rotationDir == 5) {
            v3.z -= degree;
        }
        else if (this.rotationDir == 6) {
            v3.z += degree;
        }
        this.nodeMyBox.eulerAngles = v3;
        // curQuad = curQuad.fromEuler(v3);
        // console.log(curQuad)
        if (this.totalDegree >= 90) {
            this.rotationDir = 0;
            this.totalDegree = 0;
        }
        // let quat = new cc.Quat(0, 0, 0, 1);
        // quat.w = out.w * curQuad.w - out.x * curQuad.x - out.y * curQuad.y - out.z * curQuad.z;
        // quat.x = out.w * curQuad.x + out.x * curQuad.w + out.y * curQuad.z - out.z * curQuad.y;
        // quat.y = out.w * curQuad.y - out.x * curQuad.z + out.y * curQuad.w + out.z * curQuad.x;
        // quat.z = out.w * curQuad.z + out.x * curQuad.y - out.y * curQuad.x + out.z * curQuad.w;
        // (this.nodeMyBox as any).setWorldRotation(quat);
        // this.nodeMyBox.eulerAngles = this.nodeMyBox.eulerAngles;
        console.log("degree=" + degree + ", dir=" + this.rotationDir);
        console.log(v3);
    };
    Box.prototype.onClickUp = function () {
        console.log("click up, ", this.nodeMyBox.eulerAngles);
        this.nodeMyBox.eulerAngles = new cc.Vec3(0, -90, -90);
        return;
        // let quat = new cc.Quat(Math.sqrt(0.5), 0, 0, Math.sqrt(0.5));
        // (this.nodeMyBox as any).setWorldRotation(quat);
        // this.nodeMyBox.eulerAngles = this.nodeMyBox.eulerAngles;
        // return;
        // let out: any = {};
        // console.log((this.nodeMyBox as any).getWorldRotation(out))
        if (this.rotationDir)
            return;
        if (Math.abs(this.nodeMyBox.eulerAngles.y) < 1 && Math.abs(Math.abs(this.nodeMyBox.eulerAngles.y) - 180) < 1)
            this.rotationDir = 1;
        else
            this.rotationDir = 5;
        return;
        this.nodeMyBox.runAction(cc.rotate3DBy(1, 90));
        console.log(this.nodeMyBox.eulerAngles);
    };
    Box.prototype.onClickDown = function () {
        console.log("click down, ", this.nodeMyBox.eulerAngles);
        if (this.rotationDir)
            return;
        // if(Math.abs(this.nodeMyBox.eulerAngles.y) < 1 && Math.abs(Math.abs(this.nodeMyBox.eulerAngles.y) - 180) < 1) 
        this.rotationDir = 2;
        // else this.rotationDir = 6;
        return;
        this.nodeMyBox.runAction(cc.rotate3DBy(1, -90));
        console.log(this.nodeMyBox.eulerAngles);
    };
    Box.prototype.onClickLeft = function () {
        console.log("click left, ", this.nodeMyBox.eulerAngles);
        if (this.rotationDir)
            return;
        this.rotationDir = 3;
        return;
        this.nodeMyBox.runAction(cc.rotate3DBy(1, 0, 90));
        console.log(this.nodeMyBox.eulerAngles);
    };
    Box.prototype.onClickRight = function () {
        console.log("click right, ", this.nodeMyBox.eulerAngles);
        if (this.rotationDir)
            return;
        this.rotationDir = 4;
        return;
        this.nodeMyBox.runAction(cc.rotate3DBy(1, 0, -90));
        console.log(this.nodeMyBox.eulerAngles);
    };
    __decorate([
        property(cc.Node)
    ], Box.prototype, "nodeCamera", void 0);
    __decorate([
        property(cc.Node)
    ], Box.prototype, "nodeBox", void 0);
    __decorate([
        property(cc.Node)
    ], Box.prototype, "nodeMyBox", void 0);
    Box = __decorate([
        ccclass
    ], Box);
    return Box;
}(cc.Component));
exports.default = Box;

cc._RF.pop();